% Instituto Tecnolgico de Aeronutica
% Departamento de Sistemas e Controle
% 
% Disciplina: Inteligncia Artificial em Automao e Controle - 2001/01
% Professor:  Cairo Lcio Nascimento Junior
% Aluno:		  Fbio Meneghetti U. de Arajo
%
%
% 		Programa para testar uma RNA estritamente feedforward 
% treinada para reconhecimento de comandos vocais, via backpropagation .
%
% 		Verso 1.1 
%
%

clear all
close all
clc
figure;set(1,'NumberTitle','off','Resize','off','MenuBar','none','Position',[1 1 1500 750])
set(1,'Name','Reconhecimento de voz usando RNAs - Por: Fabio Meneghetti Ugulino de Araujo','Color',[.4 .6 .8])

hold on
PA0 = plot(0,0,'bs','MarkerSize',25,'LineWidth',10,'EraseMode','background');
FR0 = plot([0 0],[5 22],'b','LineWidth',10,'EraseMode','background');
RE0 = plot([0 0],[-22 -5],'b','LineWidth',10,'EraseMode','background');
DI0 = plot([5 22],[0 0],'b','LineWidth',10,'EraseMode','background');
ES0 = plot([-22 -5],[0 0],'b','LineWidth',10,'EraseMode','background');
axis([-25 25 -25 25]);axis manual;axis off
hold off

% carega dados do treinamento e a rede treinada
load traindat
load rede
testou = 1;tn = 0;
while testou ~= 2

    tn = tn + 1;
comvoc = MENU('Escolha o padro a ser testado','Frente','R','Direita','Esquerda','Pare');

      if comvoc == 1
          file = 'fr';
      elseif comvoc == 2
          file = 're';
      elseif comvoc == 3
          file = 'di';
      elseif comvoc ==4
          file = 'es';
      elseif comvoc == 5
          file = 'pa';
      end

numpad = MENU('Escolha o nmero do padro a ser testado','1','2','3','4','5');

      file = [file num2str(numpad)];
      
% Apaga ultima indicacao luminosa

if tn > 1
   if saitest(1) >= (1-(1*tol)) & saitest(2) <= -(1-(1*tol)) & saitest(3) <= -(1-(1*tol)) & saitest(4) <= -(1-(1*tol)) & saitest(5) <= -(1-(1*tol))
       delete(FR1)
       figure(1);hold on
       FR0 = plot([0 0],[5 22],'b','LineWidth',10,'EraseMode','background');hold off
   elseif saitest(1) <= -(1-(1*tol)) & saitest(2) >= (1-(1*tol)) & saitest(3) <= -(1-(1*tol)) & saitest(4) <= -(1-(1*tol)) & saitest(5) <= -(1-(1*tol))
       delete(RE1)
       figure(1);hold on
       RE0 = plot([0 0],[-22 -5],'b','LineWidth',10,'EraseMode','background');hold off
   elseif saitest(1) <= -(1-(1*tol)) & saitest(2) <= -(1-(1*tol)) & saitest(3) >= (1-(1*tol)) & saitest(4) <= -(1-(1*tol)) & saitest(5) <= -(1-(1*tol))
       delete(DI1)
       figure(1);hold on
       DI0 = plot([5 22],[0 0],'b','LineWidth',10,'EraseMode','background');hold off
   elseif saitest(1) <= -(1-(1*tol)) & saitest(2) <= -(1-(1*tol)) & saitest(3) <= -(1-(1*tol)) & saitest(4) >= (1-(1*tol)) & saitest(5) <= -(1-(1*tol))
       delete(ES1)
       figure(1);hold on
       ES0 = plot([-22 -5],[0 0],'b','LineWidth',10,'EraseMode','background');hold off
   elseif saitest(1) <= -(1-(1*tol)) & saitest(2) <= -(1-(1*tol)) & saitest(3) <= -(1-(1*tol)) & saitest(4) <= -(1-(1*tol)) & saitest(5) >= (1-(1*tol))
       delete(PA1)
       figure(1);hold on
       PA0 = plot(0,0,'bs','MarkerSize',25,'LineWidth',10,'EraseMode','background');hold off
   end
end
      
% ####################################################################

% Monta padro de treinamento

      arquiv = [file '.wav'];								% Determina arquivo a ser aberto
      [onda,freq,form] = wavread(arquiv);				    % Abre Arquivo
      sound(onda,freq);										% Reproduz comando
		fonda = abs(fft(onda,freq));     				    % Aplica FFT na onda obtendo seu espctro .
		fonda = fonda(1 : ceil(length(fonda) / 2));	        % Corta a poro simtrica da FFT.
		bonda = [];
		for i = lband : lband : 3000 + lband				% Divide a parte mais representativa do 
         bonda = [bonda sum(fonda(i : i + lband -1))];	    % espctro (de 300 a mais de 3k Hz) em bandas com largura
      end													% de lband Hz e caucula-se o padra de energia em cada banda.
      if funati == 1
         bonda = (bonda /  max(bonda)) * 2 - 1; 	        % Normaliza a representao em bandas da onda entre -1 e 1.
      else
         bonda = bonda /  max(bonda); 	                    % Normaliza a representao em bandas da onda entre 0 e 1.
      end
      p_entrada = bonda;									% Monta Padro de entrada
      
      if funati == 1
         sai = -1 * ones(1,5);sai(comvoc) = 1;
      else
         sai = zeros(1,5);sai(comvoc) = 1;
      end
      p_desejado = sai;										% Monta Padro de sada

%numpad 	==>  Nmero de padres para o treinamento
%uniin 	    ==>  Nmero de unidades na camada de entrada
%uniout 	==>  Nmero de unidades na camada de sada

[numpad,uniin]=size(p_entrada);[numpad,uniout]=size(p_desejado);

% -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
saitest = [];emq = 0;

		% Calcula os erros
		for pad = 1:numpad	
  			entrada = p_entrada(pad,:)';desejado = p_desejado(pad,:)';
           
         % Calcula sadas das unidades escondidas
			net_esc1 = pesesc1 * entrada + besc1;
         
         if funati == 1										% Tangente hiperblica
            s_esc1 = tansig(net_esc1);
			elseif funati == 2								% Sigmide
				s_esc1 = logsig(net_esc1);
			end
         
         % Calcula sada da unidade de sada
			net_saida = pesout * s_esc1 + bout;
         
         if funati == 1											% Tangente hiperblica
				saida = tansig(net_saida);
			elseif funati == 2									% Sigmide
				saida = logsig(net_saida);
			end

			saitest = [saitest saida];
			% Calcula erro entre sadas desejadas e obtidas
			saierr = desejado - saida;
			% Atualiza erro mdio quadrtico da iterao
			emq = emq + saierr' * saierr;
		end
		emq = emq / (numpad * uniout);
   
   % ==================  Mostra Resultado  Final  ====================
   for cont1=1:length(p_desejado);sep(cont1,:)='   -->   ';end
   disp(' ');
   disp(' ');
   disp(['O erro mdio quadrtico para o padro de teste foi de: ' num2str(emq)])
   disp(' ');
   disp('As Sadas desejadas e obtidas para estes pesos foram: ')
   disp([num2str(p_desejado') sep num2str(saitest)])
   disp(' ');

      tol = .20;                                                                            % Tolerancia de 20%
   if saitest(1) >= (1-(1*tol)) & saitest(2) <= -(1-(1*tol)) & saitest(3) <= -(1-(1*tol)) & saitest(4) <= -(1-(1*tol)) & saitest(5) <= -(1-(1*tol))
       figure(1);hold on
       FR1 = plot([0 0],[5 22],'g','LineWidth',15,'EraseMode','background');hold off            %frente verde
   elseif saitest(1) <= -(1-(1*tol)) & saitest(2) >= (1-(1*tol)) & saitest(3) <= -(1-(1*tol)) & saitest(4) <= -(1-(1*tol)) & saitest(5) <= -(1-(1*tol))
       figure(1);hold on
       RE1 = plot([0 0],[-22 -5],'g','LineWidth',15,'EraseMode','background');hold off          %re verde
   elseif saitest(1) <= -(1-(1*tol)) & saitest(2) <= -(1-(1*tol)) & saitest(3) >= (1-(1*tol)) & saitest(4) <= -(1-(1*tol)) & saitest(5) <= -(1-(1*tol))
       figure(1);hold on
       DI1 = plot([5 22],[0 0],'g','LineWidth',15,'EraseMode','background');hold off            %direita verde
   elseif saitest(1) <= -(1-(1*tol)) & saitest(2) <= -(1-(1*tol)) & saitest(3) <= -(1-(1*tol)) & saitest(4) >= (1-(1*tol)) & saitest(5) <= -(1-(1*tol))
       figure(1);hold on
       ES1 = plot([-22 -5],[0 0],'g','LineWidth',15,'EraseMode','background');hold off          %esquerda verde
   elseif saitest(1) <= -(1-(1*tol)) & saitest(2) <= -(1-(1*tol)) & saitest(3) <= -(1-(1*tol)) & saitest(4) <= -(1-(1*tol)) & saitest(5) >= (1-(1*tol))
       figure(1);hold on
       PA1 = plot(0,0,'rs','MarkerSize',35,'LineWidth',15,'EraseMode','background');hold off    %pare vermelho
   end

   % Plota entrada da rede
   figure
   set(2*tn,'NumberTitle','off','Resize','off','MenuBar','none','Position',[1 19 320 240],'Color',[1 1 1])
   %xbonda=1:length(bonda);
   plot(bonda,'b','LineWidth',5,'EraseMode','background');set(gca,'XLim',[1 7]);grid
   
   % Plota saida da rede
   figure
   set(2*tn+1,'NumberTitle','off','Resize','off','MenuBar','none','Position',[704 19 320 240],'Color',[1 1 1])

   for cont0=1:length(saitest)
      if cont0 > 1;hold on;end
      plot(cont0,p_desejado(cont0),'ro',[cont0,cont0],[0,saitest(cont0)],'b','MarkerSize',7,'LineWidth',4)
   end
   axis([0 length(saitest)+1 -1.1 1.1]);axis manual;axis off
   tit=(['Arq.: ' file '.wav' ', MSE = ' num2str(emq)]);
   set(2*tn+1,'Name',tit);hold off
   set(2*tn,'Name',tit);hold off
   
	% =================================================================
   
disp(' ');
resp =' ';
while resp ~= 'ok'
testou = menu('Deseja testar a rede para outro padro? ','Sim','No');
   if  testou == 1
      resp='ok';
   elseif testou == 2
      resp='ok';
   end
disp(' ');
end
disp(' ');
end
close(1)