function [errop,OutpatO,OutpatH]=calcer2(WHI,WOI,WOH,BiasH,BiasO,INPD,OUTD);
% Rotina para o calculo do erro quadratico medio de uma rede neural
% tipo feedforward com 1 camada escondida.
% COM ligacao direta entre as camadas de entrada e de saida
% Rotina auxiliar = nnout2.m
% Autores: Eduardo Botter e Cairo L. Nascimento Jr. - ITA - cairo@ita.br
% Data:  7/Set/1995, Matlab 4.x
%       11/Out/2001, Adicao da ligacao direta entre as camadas de entrada e de saida
%       10/Fev/2002, Revisao para Matlab 5.x

% Calculo do erro
global npat nout;
errop=0;
for ipat=1:npat;
    Inppat=INPD(:,ipat);
    % dim OutpatO = nout,npat
    % dim OutpatH = nhid,npat
    [OutpatO(:,ipat),OutpatH(:,ipat)]=nnout2(WHI,WOI,WOH,BiasH,BiasO,Inppat);
    % dim Verro = nout,1
    Verro=OUTD(:,ipat)-OutpatO(:,ipat);
    errop=errop+Verro'*Verro;
end;
errop=sqrt(errop)/nout;

% EOF calcer2.m
